<template>
    <div>
        <label v-if="label" :for="identifier">{{ label }}</label>
        <input
                type="datetime-local"
                :name="identifier"
                :id="identifier"
                v-model="temp_value"
                @blur="changeDateTime"
                :disabled="disabled"
        />
        <div class="fieldchanger-error" v-if="error">
            {{ error }}
        </div>
        <div class="fieldchanger-hint" v-if="hint">
            {{ hint }}
        </div>
    </div>
</template>

<script>
    import DatabaseFieldchanger from "./DatabaseFieldchanger";
    import { DatabaseFieldchangerEventBus } from '../DatabaseFieldchangerEventBus.js';
    import moment from 'moment';

    export default {

        extends: DatabaseFieldchanger,

        data() {
            return {
                temp_value: this.current_value ? moment(this.current_value).format('YYYY-MM-DD\THH:mm:ss') : null,
                old_value: this.current_value ? moment(this.current_value).format('YYYY-MM-DD HH:mm:ss') : null,
            }
        },

        methods: {
            changeDateTime(){
                this.new_value = this.temp_value ? moment(this.temp_value).format('YYYY-MM-DD HH:mm:ss') : null;
                if (this.new_value === 'Invalid date') {
                    this.error = 'Das Datum ist nicht valide'
                } else {
                    this.change();
                }
            },

            updateValues(updated_value) {
                this.old_value = updated_value ? moment(updated_value).format('YYYY-MM-DD HH:mm:ss') : null;
                this.temp_value = updated_value ? moment(updated_value).format('YYYY-MM-DD\THH:mm:ss') : null;
            }
        },

        mounted() {
            DatabaseFieldchangerEventBus.$on(this.classname + '::' + this.entity_id + '::' + this.fieldname + '::changed', this.updateValues)
        }

    }
</script>